<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="Joep Vermaat and Bootstrap contributors">
    <title>Museum Naturalis - Screenshots</title>

    <!-- Bootstrap core CSS -->

    <link href="css/bootstrap.min.css" rel="stylesheet" >
    <link href="css/album.css" rel="stylesheet">
    <link href="css/bootstrap-slider.min.css" rel="stylesheet">

  </head>
  <body>
    <header>
  <div class="collapse bg-dark" id="navbarHeader">
    <div class="container">
      <div class="row">
        <div class="col-sm-8 col-md-7 py-4">
          <h4 class="text-white">About</h4>
          <p class="text-muted">Zie, de schermen!</p>
        </div>
      </div>
    </div>
  </div>
  <div class="navbar navbar-dark bg-dark shadow-sm">
      <a href="#" class="navbar-brand d-flex align-items-center">
        <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" aria-hidden="true" class="mr-2" viewBox="0 0 24 24" focusable="false"><path d="M23 19a2 2 0 0 1-2 2H3a2 2 0 0 1-2-2V8a2 2 0 0 1 2-2h4l2-3h6l2 3h4a2 2 0 0 1 2 2z"/><circle cx="12" cy="13" r="4"/></svg>
        <strong>NATURALIS Museum - Screenshots van interactives</strong>
      </a>
      <form class="form-inline mt-2 mt-md-0">
        <input class="form-control mr-sm-2" type="text" placeholder="Search" aria-label="Search" id='filtersearch'>
      </form>
  </div>
</header>

<main role="main">

  <div class="album bg-light">

    <div class="row justify-content-md-center" id="showshots">
    </div>

  </div>

</main>

<footer class="text-muted">
  <div class="container">
    <p class="float-right">
      <a href="#">Back to top</a>
    </p>
  </div>
</footer>
    <script id="screenshot-template" type="text/template">
        <div class="col-xl-2 col-md-4 col-sm-6 col-xs-6 screenshot" id="{{ host }}">
          <div class="card lg-2 md-2 sm-6 shadow-sm">
            <a href="#{{host}}-large">
            <img class="card-img-top thumb" width="100%" height="200" focusable="false" role="img" aria-label="{{ host }}" rel="{{ host }}" src="http://{{ host }}.dw2.naturalis.nl/{{ host }}.jpg?{{ ts }}" />
            </a>
            <div class="card-body">
              <p class="card-text">{{ host }}</p>
            </div>
          </div>
          <div class="lightbox" id="{{ host }}-large">
            <a href="#_" class="btn-close">X</a>
            <img src="http://{{ host }}.dw2.naturalis.nl/{{ host }}.jpg?{{ ts }}">
            <div class="time-nav">
                <div class="date-selector"></div>
                <div class="time-selector"></div>
            </div>
          </div>

        </div>
    </script>
    <script src="js/jquery.min.js" ></script>
    <script src="js/bootstrap.min.js" ></script>
    <script src="js/mustache.min.js" ></script>
    <script src="js/bootstrap-slider.min.js" ></script>
    <script>
        function addshot(hostname) {
            var unix = Math.round(+new Date()/1000);
            var data = {
                host: hostname,
                ts: unix
            }
            var template = $('#screenshot-template').html();
            var html = Mustache.render(template, data);
            $('#showshots').append(html);
        }

        function showall() {
            $('.screenshot').show();
        }

        function hideall() {
            $('.screenshot').hide();
        }


        function filterscreen(search) {
            hideall();
            $('.screenshot').filter(function() {
                var reg = new RegExp(search);
                return this.id.match(reg);
            }).show();
        }

        function buildTimescrubber(host) 
        {
            var url = 'http://' + host + '.dw2.naturalis.nl/';
            var ds = $('#' + host + '-large .date-selector select')[0];
            var today = ds.value;
            $.get(url + today + '/', function(raw) {
                raw.reverse();

                var data = raw.filter(function (el) {
                  return el.type == 'file'
                });

                var screen = data[0];
                $('#' + host + '-large img').attr('src', url + today + '/' + screen.name);
                var timeslider = $('#' + host + '-large .time-selector').slider({
                    id: host + '-timetraveler',
                    min: 0,
                    max: data.length - 1,
                    value: 0,
                    reversed: true,
                    tooltip: 'always',
                    tooltip_position: 'bottom',
                    formatter: function(position) {
                        var nr = data.length - position
                        var screen = data[position];
                        var thetime = new Date(screen.mtime);
                        var minutes = (thetime.getMinutes() < 10 ? '0' : '') + thetime.getMinutes();

                        return nr + ' @ ' + thetime.getHours() + ':' + minutes;
                    }
                }).on('slideStop', function(event) {
                    var position = event.value;
                    var screen = data[position];

                    if (screen) {
                        $('#' + host + '-large img').attr('src', url + today + '/' + screen.name);
                    }
                });
                timeslider.slider('refresh');
            });
        }

        $(function() {
            var hosts = [
                "cabinijsland-cmp-1",
                "camarasaurus-cmp-1",
                "camperhawaii-cmp-1",
                "camperjapan-cmp-1",
                "camperjapan-cmp-2",
                "datingquiz-cmp-1",
                "digibieb-cmp-1",
                "digibieb-cmp-2",
                "dinovoetstappen-cmp-1",
                "edmontosaurus-cmp-1",
                "filmdubois-cmp-1",
                "flipperkast-cmp-1",
                "gameover-cmp-1",
                "greenporn-cmp-1",
                "handscanner-cmp-1",
                "introjapanstheater-cmp-1",
                "kijkersbrabant-cmp-1",
                "kijkersbrabant-cmp-2",
                "kijkersbrabant-cmp-3",
                "kijkersdrenthe-cmp-1",
                "kijkersdrenthe-cmp-2",
                "kijkersdrenthe-cmp-3",
                "kijkersfriesland-cmp-1",
                "kijkersfriesland-cmp-2",
                "kijkersfriesland-cmp-3",
                "kijkersgelderland-cmp-1",
                "kijkersgelderland-cmp-2",
                "kijkersgelderland-cmp-3",
                "kijkersholland-cmp-1",
                "kijkersholland-cmp-2",
                "kijkersholland-cmp-3",
                "letsdance-cmp-1",
                "naturalisdigitaal-cmp-1",
                "signageservicebalie-cmp-1",
                "signageservicebalie-cmp-2",
                "signageservicebalie-cmp-3",
                "signageservicebalie-cmp-4",
                "plateosaurus-cmp-1",
                "projectiebeweging-cmp-1",
                "projectiedans-cmp-1",
                "projectiediepzee-cmp-1",
                "projectiegetijden-cmp-1",
                "projectiegiraf-cmp-1",
                "projectiekleinedieren-cmp-1",
                "projectieluchtdieren-cmp-1",
                "projectieolifant-cmp-1",
                "projectieauditorium-cmp-1",
                "sexystories-cmp-1",
                "speelnest-cmp-1",
                "spermarace-cmp-1",
                "stegosaurus-cmp-1",
                "timelapse-cmp-1",
                "trex-cmp-1",
                "triceratops-cmp-1",
                "vroegemensportaal-cmp-1",
                "waternesten-cmp-1",
                "waterwand-cmp-1",
                "monitorenontvangsthal-cmp-1",
                "knaagdierontvangsthal-cmp-1",
                "ontsmettingszone-cmp-1",
                "monitorenjungle-cmp-1",
                "monitorenjungle-cmp-2",
                "monitorenjungle-cmp-3"
            ]


            hosts.forEach(function (host, index) {
                addshot(host);
            });

            $('#filtersearch').keyup(function() {
                var search = $(this).val();
                if (search) {
                    filterscreen(search);
                } else {
                    showall();
                }
            });
            $('#filtersearch').focus();

            $('.thumb').click(function() {
                var host = $(this).attr('rel');
                var url = 'http://' + host + '.dw2.naturalis.nl/';
                $.get(url,
                    function(data) {
                        var selectDate = document.createElement("select");
                        data.reverse();
                        $(data).each(function (index) {
                            if (this.type == 'directory') {
                                var option = document.createElement("option");
                                option.value = this.name;
                                option.text = this.name;
                                selectDate.appendChild(option);
                            }
                        });

                        $('#' + host + '-large .date-selector').empty();
                        $('#' + host + '-large .date-selector').append(selectDate);
                        buildTimescrubber(host);

                        $('#' + host + '-large .date-selector select').attr('class', 'custom-select');

                        $('#' + host + '-large .date-selector select').on('change', function() {
                            buildTimescrubber(host);
                        });
                    }
                );

            });
        });

        setInterval(function() {
            var unix = Math.round(+new Date()/1000);
            var shots = $('.screenshot img');
            $(shots).each(function (index) {
                var src = $(this).attr('src');
                if (src) {
                    var newsrc = src.split('?')[0] + '?' + unix;
                    $(this).attr('src',newsrc);
                }
            });
            $('.screenshot img').on("error", function() {
                $(this).attr('src', 'img/noise.gif');
            });
        }, 20000);

    </script>
  </body>
</html>
